//AbstandZwischenRahmen_301d.js
// 22.12.09 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / <hsa@ringier.ch>
//DESCRIPTION:Zeigt die horizontale und vertikale Distanz zweier Rahmen an.

// vorsichtshalber die Dialoge einschalten
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// testen, ob ein Dokument geffnet ist
if (app.documents.length == 0) {
	alert ("Es ist kein Dokument offen.", "Achtung");
	exit();
}

var curDoc = app.documents[0];

// die Auswahl speichern
var curSel = app.selection;

// testen, ob zwei Objekte ausgewhlt sind
if (curSel.length == 0) {
	alert ("Bitte zwei Rahmen auswhlen.", "Achtung");
	exit();
}
else if (curSel.length == 1) {
	alert ("Bitte einen *zweiten* Rahmen auswhlen.", "Achtung");
	exit();
}
else if (curSel.length > 2) {
	alert ("Bitte *nur zwei* Rahmen auswhlen.", "Achtung");
	exit();
}

// die Masseinheiten speichern
// wenn nicht 2053991795 (= Millimeter), auf Millimeter umstellen
hM = curDoc.viewPreferences.horizontalMeasurementUnits;
vM = curDoc.viewPreferences.verticalMeasurementUnits;
if (hM != 2053991795) {
	curDoc.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.millimeters;
}
if (vM != 2053991795) {
	curDoc.viewPreferences.verticalMeasurementUnits = MeasurementUnits.millimeters;
}

// den Linealursprung speichern und modifizieren (falls notwendig)
var rO = curDoc.viewPreferences.rulerOrigin;
if (rO != 1380143983) {
	curDoc.viewPreferences.properties = {rulerOrigin:RulerOrigin.spreadOrigin};
}

// die Bounds der Auswahl speichern
var gA = curSel[0].geometricBounds;
var gB = curSel[1].geometricBounds;
var vA = curSel[0].visibleBounds;
var vB = curSel[1].visibleBounds;
var hgDiff, vgDiff, hvDiff, vvDiff;

// die horizontalen Werte ausrechnen
if ((gA[1] - gB[1]) > 0) {
	hgDiff = gA[1] - gB[3];
}
else {
	hgDiff = gB[1] - gA[3];
}
hgDiff = (Math.floor((hgDiff*1000)+0.5))/1000;

if ((vA[1] - vB[1]) > 0) {
	hvDiff = vA[1] - vB[3];
}
else {
	hvDiff = vB[1] - vA[3];
}
hvDiff = (Math.floor((hvDiff*1000)+0.5))/1000;

// die vertikalen Werte ausrechnen
if ((gA[0] - gB[0]) > 0) {
	vgDiff = gA[0] - gB[2];
}
else {
	vgDiff = gB[0] - gA[2];
}
vgDiff = (Math.floor((vgDiff*1000)+0.5))/1000;

if ((vA[0] - vB[0]) > 0) {
	vvDiff = vA[0] - vB[2];
}
else {
	vvDiff = vB[0] - vA[2];
}
vvDiff = (Math.floor((vvDiff*1000)+0.5))/1000;

// den Benutzer benachrichtigen
alert ("--------------------------------\nGeometrische Abstnde =\n\nhorizontal  " + hgDiff + " mm\n\nvertikal      " 
+ vgDiff + " mm\n\n--------------------------------\nSichtbare Abstnde =\n\nhorizontal  " + 
hvDiff + " mm\n\nvertikal      " + vvDiff + " mm", " ");

// Masseinheiten zurcksetzen (falls notwendig)
function reStore() {
	if (hM != 2053991795) {
		curDoc.viewPreferences.horizontalMeasurementUnits = hM;
	}
	if (vM != 2053991795) {
		curDoc.viewPreferences.verticalMeasurementUnits = vM;
	}
}

// Linealursprung zurcksetzen (falls notwendig)
if (rO != 1380143983) {
	curDoc.viewPreferences.rulerOrigin = rO;
}